/*
 * This file is part of the digitalSTROM ds485-core library.
 *
 * Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland
 *
 * digitalSTROM ds485-core library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation version 2
 * of the License.
 *
 * digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with digitalSTROM ds485-core library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef __DSUID_HELPER_H__
#define __DSUID_HELPER_H__

#include <stdbool.h>

#include <digitalSTROM/dsuid.h>

extern dsuid_t NO_DEVICE;

bool isAddressValid(uint8_t addr);
void copy_dsuids(dsuid_t *list, int size);

const dsuid_t *get_dsuid(uint8_t addr);
void set_dsuid(uint8_t addr, const dsuid_t *dsuid);

uint8_t get_short_address(const dsuid_t *dsuid);

void dsuidToString(const dsuid_t *dsuid, char *dsuid_str);

dsuid_t ds485_dsid_to_dsuid(const dsid_t *dsid);


#endif
