/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _ds485_linux_h
#define _ds485_linux_h

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <syslog.h>
#include <termios.h>
#include <unistd.h>
#include <signal.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <sys/utsname.h>
#include <semaphore.h>

#include    "tty.h"
#include    "digitalSTROM/ds485-core.h"
#include    "callqueue.h"

typedef struct
{
    char* devName;                    /* Device name operating on */

    ds485_api_callback_msg_t          callback_msg_handler;
    ds485_api_callback_bus_change_t   busChange;
    ds485_api_callback_state_t        state;
    int                               logFd;

    CcInst_t         reqBusMembers;
    QEvent const *   reqBusMembersSto[1];
    CcInst_t         reqBusState;
    QEvent const *   reqBusStateSto[1];

//    callback_state_t        busStateChangeCallback;

    sem_t   semRx;
    sem_t   semTx;

    /* threads */

    pthread_t rxThread;
    pthread_t qpThread;

    pthread_mutex_t logMutex;

    /* platform device data */

    Tty_t    tty;

    int mainActive;
    int serialLoopback;

} Ds485LibInst_t;

int ds485_system_tx();



#endif

